package com.swiftcleaner.chovey.view.activity;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.LinearLayoutManager;

import android.Manifest;
import android.animation.ValueAnimator;
import android.app.Activity;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Build;
import android.os.CountDownTimer;
import android.os.Environment;
import android.provider.Settings;
import android.view.View;
import android.widget.Toast;

import com.gyf.immersionbar.ImmersionBar;
import com.swiftcleaner.chovey.R;
import com.swiftcleaner.chovey.business.EventUtils;
import com.swiftcleaner.chovey.business.admob.AdmobManager;
import com.swiftcleaner.chovey.databinding.ActivityBatteryInfoBinding;
import com.swiftcleaner.chovey.model.bean.AppInfoBean;
import com.swiftcleaner.chovey.model.util.AppSchedulers;
import com.swiftcleaner.chovey.model.util.FinishMain;
import com.swiftcleaner.chovey.view.BaseActivity;
import com.swiftcleaner.chovey.view.BaseActivityKotlin;
import com.swiftcleaner.chovey.view.MainActivity;
import com.swiftcleaner.chovey.view.adapter.AppInfoAdapter;
import com.swiftcleaner.chovey.view.dialog.CustomScoreDialog;
import com.swiftcleaner.chovey.view.dialog.LoadingDialog;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import io.reactivex.rxjava3.disposables.Disposable;

public class BatteryInfoActivity extends BaseActivity<ActivityBatteryInfoBinding> {
    private AppInfoAdapter adapter;
    private Disposable disposable;
    private ValueAnimator animator;
    private CountDownTimer countDownTimer;
    private static final int REQUEST_ALL_FILES_ACCESS_PERMISSION = 100;
    private static final int REQUEST_PERMISSION_CODE = 101;

    @Override
    protected ActivityBatteryInfoBinding getViewBinding() {
        return ActivityBatteryInfoBinding.inflate(getLayoutInflater());
    }

    @Override
    protected void initView() {
        initBar();
    }

    @Override
    protected void initData() {
        EventUtils.INSTANCE.event("page_BatteryInfoActivity", "", null);
        initPage();
        initShow();
    }

    private void initPage() {
        binding.clRadarview.setVisibility(View.VISIBLE);
        binding.radarview.setSearching(true);
        AdmobManager.INSTANCE.showNativeAd(BatteryInfoActivity.this, (nativeAd) -> {
            binding.flAdDonghua.removeAllViews();
            binding.flAdDonghua.setNativeAd(nativeAd, R.layout.layout_ad_native);
            return null;
        }, null, null);
        initAnimotor();
        countDownTimer = new CountDownTimer(5000, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
            }

            @Override
            public void onFinish() {
                binding.radarview.setSearching(false);
                countDownTimer.cancel();
                animator.cancel();
                binding.clRadarview.setVisibility(View.GONE);
                LoadingDialog loadingDialog = new LoadingDialog(BatteryInfoActivity.this);
                loadingDialog.show();
                if (AdmobManager.INSTANCE.isShowAdInter()) {
                    AdmobManager.INSTANCE.showInterstitialAd(BatteryInfoActivity.this, () -> {
                                return null;
                            },
                            () -> {
                                checkAndRequestPermissions();
                                loadingDialog.dismiss();
                                binding.flAdDonghua.removeAllViews();
                                return null;
                            },
                            () -> {
                                checkAndRequestPermissions();
                                loadingDialog.dismiss();
                                binding.flAdDonghua.removeAllViews();
                                return null;
                            }, false);
                } else {
                    checkAndRequestPermissions();
                    loadingDialog.dismiss();
                }
            }
        }.start();
        AdmobManager.INSTANCE.showNativeAd(BatteryInfoActivity.this, (nativeAd) -> {
            binding.flAd.removeAllViews();
            binding.flAd.setNativeAd(nativeAd, R.layout.layout_ad_native);
            return null;
        }, null, null);
    }

    private void checkAndRequestPermissions() {
        if (!checkFilesAccessPermission(this)) {
            // 没有权限，请求权限
            requestFilesAccessPermission();
        }
    }

    private boolean checkFilesAccessPermission(Context context) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            return Environment.isExternalStorageManager();
        } else {
            int readPermission = ContextCompat.checkSelfPermission(context, Manifest.permission.READ_EXTERNAL_STORAGE);
            int writePermission = ContextCompat.checkSelfPermission(context, Manifest.permission.WRITE_EXTERNAL_STORAGE);
            return readPermission == PackageManager.PERMISSION_GRANTED && writePermission == PackageManager.PERMISSION_GRANTED;
        }
    }

    private void requestFilesAccessPermission() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            try {
                Intent intent = new Intent(Settings.ACTION_MANAGE_APP_ALL_FILES_ACCESS_PERMISSION);
                intent.addCategory("android.intent.category.DEFAULT");
                intent.setData(Uri.parse("package:" + getPackageName()));
                startActivityForResult(intent, REQUEST_ALL_FILES_ACCESS_PERMISSION);
            } catch (ActivityNotFoundException e) {
                Toast.makeText(this, "Unable to request permission, please grant manually", Toast.LENGTH_SHORT).show();
            }
        } else {
            ActivityCompat.requestPermissions(this, new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE}, REQUEST_PERMISSION_CODE);
        }
    }
    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == REQUEST_ALL_FILES_ACCESS_PERMISSION) {
            // 检查权限是否已经授予
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
                if (Environment.isExternalStorageManager()) {
                    // 权限已授予，刷新页面或执行相关操作
                    Intent intent = new Intent(this, MainActivity.class);
                    startActivity(intent);
                    finish();
                } else {
                    // 权限未授予，提示用户
                    Toast.makeText(this, "Permission not granted, please grant manually", Toast.LENGTH_SHORT).show();
                }
            }
        }
    }
    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == REQUEST_ALL_FILES_ACCESS_PERMISSION) {
            if (!checkFilesAccessPermission(this)) {
                // 权限未授予，直接关闭页面
                Toast.makeText(this, "Unauthorized permission, the page is about to close", Toast.LENGTH_SHORT).show();
                finish();
            }
        } else if (requestCode == REQUEST_PERMISSION_CODE) {
            if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED) {
                // 权限已授予，可以继续操作
            } else {
                // 权限未授予，直接关闭页面
                Toast.makeText(this, "Unauthorized permission, the page is about to close", Toast.LENGTH_SHORT).show();
                finish();
            }
        }
    }

    private void initAnimotor() {
        // 创建ValueAnimator，从1到100
        animator = ValueAnimator.ofInt(1, 100);
        animator.setDuration(5000); // 3秒

        // 设置更新监听器，每帧更新进度文本
        animator.addUpdateListener(new ValueAnimator.AnimatorUpdateListener() {
            @Override
            public void onAnimationUpdate(ValueAnimator animation) {
                int currentValue = (int) animation.getAnimatedValue();
                binding.parText.setText(currentValue + "%");
            }
        });
        // 开始动画
        animator.start();
    }

    private void initShow() {
        binding.idActivityAppmanagerLoading.setVisibility(View.VISIBLE);

        disposable = Observable.fromCallable(() -> {
                    PackageManager packageManager = getPackageManager();
                    List<ApplicationInfo> installedApps = packageManager.getInstalledApplications(0);

                    // 过滤掉系统应用
                    List<ApplicationInfo> nonSystemApps = new ArrayList<>();
                    for (ApplicationInfo appInfo : installedApps) {
                        if ((appInfo.flags & ApplicationInfo.FLAG_SYSTEM) == 0) {
                            nonSystemApps.add(appInfo);
                        }
                    }

                    // 过滤掉当前应用
                    List<ApplicationInfo> nonSystemAppsFiltered = new ArrayList<>();
                    String currentPackageName = getPackageName();
                    for (ApplicationInfo appInfo : nonSystemApps) {
                        if (!currentPackageName.equals(appInfo.packageName)) {
                            nonSystemAppsFiltered.add(appInfo);
                        }
                    }

                    // 将ApplicationInfo对象转换为AppInfoBean对象
                    List<AppInfoBean> apps = new ArrayList<>();
                    for (ApplicationInfo packageInfo : nonSystemAppsFiltered) {
                        String appName = packageManager.getApplicationLabel(packageInfo).toString();
                        Drawable appIcon = packageInfo.loadIcon(packageManager);
                        AppInfoBean appInfoBean = new AppInfoBean(appName, appIcon, packageInfo.packageName);
                        apps.add(appInfoBean);
                    }
                    return apps;
                }).subscribeOn(AppSchedulers.io())
                .observeOn(AppSchedulers.mainThread())
                .subscribe(apps -> {
                    binding.tvBatteryInfoNum.setText("(" + apps.size() + " in total)");
                    binding.batteryRecy.setLayoutManager(new LinearLayoutManager(BatteryInfoActivity.this));
                    adapter = new AppInfoAdapter(apps, BatteryInfoActivity.this);
                    binding.batteryRecy.setAdapter(adapter);
                    binding.ivReturn.setOnClickListener(v -> {
                        initCustDialog();
                    });
                    binding.idActivityAppmanagerLoading.setVisibility(View.GONE);
                }, throwable -> {
                    // 处理错误
                    throwable.printStackTrace();
                });


    }

    private void initBar() {
        ImmersionBar.with(this)
                .transparentStatusBar()  // 透明状态栏
                .statusBarDarkFont(false)  // 状态栏字体颜色为深色
                .navigationBarDarkIcon(true)  // 导航栏图标颜色为浅色
                .init();
    }

    @Override
    public void onBackPressed() {

        initCustDialog();
    }

    private void initCustDialog() {
        Activity activity = this;
        CustomScoreDialog customScoreDialog = new CustomScoreDialog(this);
        customScoreDialog.setOnDialogClickListener(new CustomScoreDialog.OnDialogClickListener() {
            @Override
            public void onCancel() {
                customScoreDialog.dismiss();
            }

            @Override
            public void onSubmit() {
                if (AdmobManager.INSTANCE.isShowAdBackInter()){
                    AdmobManager.INSTANCE.showInterstitialAd(BatteryInfoActivity.this, () -> {
                                FinishMain.INSTANCE.finishToMain(activity);
                                return null;
                            },
                            () -> {

                                return null;
                            },
                            () -> {
                                FinishMain.INSTANCE.finishToMain(activity);
                                return null;
                            }, false);
                }else {
                    FinishMain.INSTANCE.finishToMain(activity);
                }


            }
        });
        customScoreDialog.show();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (disposable != null && !disposable.isDisposed()) {
            disposable.dispose();
        }
        if (binding.radarview != null) {
            binding.radarview.setSearching(false);
        }
        if (animator != null) {
            animator.cancel();
        }
        if (countDownTimer != null) {
            countDownTimer.cancel();
        }
    }
}